{ Install this component using Options|Install Compenents.
  The function of this module is to provide Delphi 1.x with a
  component capable of performing a highlight over a speedbutton
  when the mouse is over it.

  The code herein is released to the public domain under the condition
  that it will not be used for commercial or "For Profit" ventures.
  This code is considered swap-ware.  If you use it, hack around with it etc.
  Yu must send me something in return.  Weather it be a postcard (minimum) or
  some cash (highly recomemended if you use it in a comercial program) or whatever.

  Written By:      Neal Walfield
  Date:            July 16th, 1997.
  Copyright:       (R) Copyright by Neal Walfield, 1997. All Rights Reserved
  UserID(s):       brin@star.net
                   Contentio@geocities.com  (More Stable)
  Address:         4 Wiseman Dr.
                   Peabody, MA 01960
                   USA

  Description:     This control creates a highlighted area around a speedbutton when
                   the mouse is over it.

  XSpeedBtn v1.00
}
unit SpeedBtn;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, Buttons;

type
  XSpeedButton = class(TSpeedButton)
  private
    { Private declarations }
    Over : Boolean;
    VShadow, VHighLight : TColor;
  protected
    { Protected declarations }
    Procedure MouseMove(Shift: TShiftState; X, Y: Integer); override;
    Procedure Paint; override;
    Procedure Click; override;
    Procedure DBLClick; override;
  public
    { Public declarations }
    Constructor Create(AOwner: TComponent); override;
  published
    { Published declarations }
    property Shadow : TColor read VShadow write VShadow;
    property HighLight : TColor read VHighLight write VHighLight;
  end;


procedure Register;

implementation

procedure Register;
begin
  RegisterComponents('Samples', [XSpeedButton]);
end;

Constructor XSpeedButton.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
  Over := False;
  HighLight := clWhite;
  Shadow := clGray;
end;

Procedure XSpeedButton.MouseMove(Shift: TShiftState; X, Y: Integer);
var
  TheRect : TRect;
begin
  inherited MouseMove(Shift, X, Y);

  if not Over then begin
    Over := True;
    SetCaptureControl(Self);
    Refresh;
  end;
  if (X < 0) or (X > Width) or (Y < 0) or (Y > Height) then begin
    Over := False;
    SetCaptureControl(Nil);
    Refresh;
  end;
end;

Procedure XSpeedButton.Paint;
begin
  Inherited Paint;

  if Over then
    with Canvas do begin
      Pen.Width := 1;
      Pen.Color := HighLight;
      MoveTo(Width-1, 0);
      LineTo(0, 0);
      LineTo(0, Height-1);
      Pen.Color := Shadow;
      LineTo(Width-1, Height-1);
      LineTo(Width-1, 0);
    end;
end;

Procedure XSpeedButton.Click;
begin
  MouseMove([], -1, -1);

  Inherited Click;
end;

Procedure XSpeedButton.DBLClick;
begin
  MouseMove([], -1, -1);

  Inherited Click;
end;

end.
